<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { getClient } from '~/plugins/contentful';
import { CONTENT_TYPES } from '~/common/content-types';
import { getPageMetadata } from '~/common/meta';
import { ContentfulLivePreview } from '@contentful/live-preview';

import { micrositeDataHelper } from '~/services/microsites/microsite.service';

import {
  MicrositeCtaTabs,
  MicrositeFooterCta,
  MicrositeNavigation,
  MicrositePageBody,
} from '~/components/microsites/index.vue';
import { LivePreviewMixin } from '~/mixins';
export default Vue.extend({
  components: {
    MicrositeNavigation,
    MicrositePageBody,
    MicrositeFooterCta,
    MicrositeCtaTabs,
  },
  nuxtI18n: false,
  mixins: [LivePreviewMixin],
  layout: 'microsite',
  async data() {
    return {
      metadata: null,
      data: null,
    };
  },
  fetchOnServer: false,
  async fetch() {
    const id = this.$route.query.id;
    const config = {
      accessToken: this.$config.preview,
      space: this.$config.space,
      host: 'preview.contentful.com',
    };
    try {
      const micrositeData = await getClient(config).getEntries({
        'sys.id': id,
        content_type: CONTENT_TYPES.MICROSITE,
        include: 10,
      });
      const [microsite] = micrositeData.items;
      const metadata = microsite.fields.seoMetadata.fields;
      const data = micrositeDataHelper(microsite.fields);
      this.metadata = metadata;
      this.data = data;
    } catch (e) {
      throw new Error(e);
    }
  },
  head(): MetaInfo {
    try {
      const metadata = {
        ...(this.metadata || {}),
        noIndex: true,
      };
      return getPageMetadata(metadata, this.$route.path);
    } catch (e) {
      throw new Error(e);
    }
  },
  mounted() {
    if (this.isPreview) {
      const unsubscribeFn = ContentfulLivePreview.subscribe({
        data: this.data,
        callback: (updatedData) => {
          this.data = updatedData;
        },
      });
      this.livePreviewSubscriptions.push(unsubscribeFn);
    }
  },
});
</script>
<template>
  <div v-if="!$fetchState.pending">
    <MicrositeNavigation
      :partner="data.partner"
      :navigation="data.navigation"
    />
    <main>
      <SlpContainer>
        <SlpTypography class="header" variant="heading1-bold" tag="h1">
          {{ data.content.heading }}
        </SlpTypography>
        <MicrositeCtaTabs
          class="mobile-tabs"
          :data="data.content.body.sideMenu.tabs"
          :partner="data.partner"
        />
        <div class="main-content">
          <MicrositePageBody :data="data.content.body" />
        </div>
      </SlpContainer>
    </main>
    <SlpContainer variant="gradient">
      <MicrositeFooterCta :data="data.footerCta.data" :partner="data.partner" />
    </SlpContainer>
  </div>
</template>

<style lang="scss" scoped>
main {
  margin-top: 16px;
}
.header {
  display: block;
  width: 75%;

  @media (max-width: $breakpoint-md) {
    width: 100%;
  }
}

.mobile-tabs {
  display: none;

  @media (max-width: $breakpoint-md) {
    margin-top: 32px;
    display: block;
  }
}

.main-content {
  padding-top: 64px;

  @media (max-width: $breakpoint-md) {
    padding-top: 0;
  }
}
</style>
